   SECTION('Equates')
!
FTP_TRANSFER_TYPE_UNKNOWN   EQUATE(00000000h)
FTP_TRANSFER_TYPE_ASCII     EQUATE(00000001h)
FTP_TRANSFER_TYPE_BINARY    EQUATE(00000002h)
!------------------------------------------------------------------------------
INTERNET_FLAG_TRANSFER_ASCII    EQUATE(FTP_TRANSFER_TYPE_ASCII)     ! 00000001h
INTERNET_FLAG_TRANSFER_BINARY   EQUATE(FTP_TRANSFER_TYPE_BINARY)    ! 00000002h
!
!==============================================================================
!
! handle types
!
INTERNET_HANDLE_TYPE_INTERNET           EQUATE(1)
INTERNET_HANDLE_TYPE_CONNECT_FTP        EQUATE(2)
INTERNET_HANDLE_TYPE_CONNECT_GOPHER     EQUATE(3)
INTERNET_HANDLE_TYPE_CONNECT_HTTP       EQUATE(4)
INTERNET_HANDLE_TYPE_FTP_FIND           EQUATE(5)
INTERNET_HANDLE_TYPE_FTP_FIND_HTML      EQUATE(6)
INTERNET_HANDLE_TYPE_FTP_FILE           EQUATE(7)
INTERNET_HANDLE_TYPE_FTP_FILE_HTML      EQUATE(8)
INTERNET_HANDLE_TYPE_GOPHER_FIND        EQUATE(9)
INTERNET_HANDLE_TYPE_GOPHER_FIND_HTML   EQUATE(10)
INTERNET_HANDLE_TYPE_GOPHER_FILE        EQUATE(11)
INTERNET_HANDLE_TYPE_GOPHER_FILE_HTML   EQUATE(12)
INTERNET_HANDLE_TYPE_HTTP_REQUEST       EQUATE(13)
!
! common per-API flags (new APIs)
!
WININET_API_FLAG_ASYNC          EQUATE(00000001h)  ! force async operation
WININET_API_FLAG_SYNC           EQUATE(00000004h)  ! force sync operation
WININET_API_FLAG_USE_CONTEXT    EQUATE(00000008h)  ! use value supplied in dwContext (even if 0)
!
!=======================================================================
!
INTERNET_ERROR_BASE                     EQUATE(12000)
!
ERROR_INTERNET_OUT_OF_HANDLES           EQUATE(INTERNET_ERROR_BASE + 1)
ERROR_INTERNET_TIMEOUT                  EQUATE(INTERNET_ERROR_BASE + 2)
ERROR_INTERNET_EXTENDED_ERROR           EQUATE(INTERNET_ERROR_BASE + 3)
ERROR_INTERNET_INTERNAL_ERROR           EQUATE(INTERNET_ERROR_BASE + 4)
ERROR_INTERNET_INVALID_URL              EQUATE(INTERNET_ERROR_BASE + 5)
ERROR_INTERNET_UNRECOGNIZED_SCHEME      EQUATE(INTERNET_ERROR_BASE + 6)
ERROR_INTERNET_NAME_NOT_RESOLVED        EQUATE(INTERNET_ERROR_BASE + 7)
ERROR_INTERNET_PROTOCOL_NOT_FOUND       EQUATE(INTERNET_ERROR_BASE + 8)
ERROR_INTERNET_INVALID_OPTION           EQUATE(INTERNET_ERROR_BASE + 9)
ERROR_INTERNET_BAD_OPTION_LENGTH        EQUATE(INTERNET_ERROR_BASE + 10)
ERROR_INTERNET_OPTION_NOT_SETTABLE      EQUATE(INTERNET_ERROR_BASE + 11)
ERROR_INTERNET_SHUTDOWN                 EQUATE(INTERNET_ERROR_BASE + 12)
ERROR_INTERNET_INCORRECT_USER_NAME      EQUATE(INTERNET_ERROR_BASE + 13)
ERROR_INTERNET_INCORRECT_PASSWORD       EQUATE(INTERNET_ERROR_BASE + 14)
ERROR_INTERNET_LOGIN_FAILURE            EQUATE(INTERNET_ERROR_BASE + 15)
ERROR_INTERNET_INVALID_OPERATION        EQUATE(INTERNET_ERROR_BASE + 16)
ERROR_INTERNET_OPERATION_CANCELLED      EQUATE(INTERNET_ERROR_BASE + 17)
ERROR_INTERNET_INCORRECT_HANDLE_TYPE    EQUATE(INTERNET_ERROR_BASE + 18)
ERROR_INTERNET_INCORRECT_HANDLE_STATE   EQUATE(INTERNET_ERROR_BASE + 19)
ERROR_INTERNET_NOT_PROXY_REQUEST        EQUATE(INTERNET_ERROR_BASE + 20)
ERROR_INTERNET_REGISTRY_VALUE_NOT_FOUND EQUATE(INTERNET_ERROR_BASE + 21)
ERROR_INTERNET_BAD_REGISTRY_PARAMETER   EQUATE(INTERNET_ERROR_BASE + 22)
ERROR_INTERNET_NO_DIRECT_ACCESS         EQUATE(INTERNET_ERROR_BASE + 23)
ERROR_INTERNET_NO_CONTEXT               EQUATE(INTERNET_ERROR_BASE + 24)
ERROR_INTERNET_NO_CALLBACK              EQUATE(INTERNET_ERROR_BASE + 25)
ERROR_INTERNET_REQUEST_PENDING          EQUATE(INTERNET_ERROR_BASE + 26)
ERROR_INTERNET_INCORRECT_FORMAT         EQUATE(INTERNET_ERROR_BASE + 27)
ERROR_INTERNET_ITEM_NOT_FOUND           EQUATE(INTERNET_ERROR_BASE + 28)
ERROR_INTERNET_CANNOT_CONNECT           EQUATE(INTERNET_ERROR_BASE + 29)
ERROR_INTERNET_CONNECTION_ABORTED       EQUATE(INTERNET_ERROR_BASE + 30)
ERROR_INTERNET_CONNECTION_RESET         EQUATE(INTERNET_ERROR_BASE + 31)
ERROR_INTERNET_FORCE_RETRY              EQUATE(INTERNET_ERROR_BASE + 32)
ERROR_INTERNET_INVALID_PROXY_REQUEST    EQUATE(INTERNET_ERROR_BASE + 33)
ERROR_INTERNET_NEED_UI                  EQUATE(INTERNET_ERROR_BASE + 34)
!
ERROR_INTERNET_HANDLE_EXISTS            EQUATE(INTERNET_ERROR_BASE + 36)
ERROR_INTERNET_SEC_CERT_DATE_INVALID    EQUATE(INTERNET_ERROR_BASE + 37)
ERROR_INTERNET_SEC_CERT_CN_INVALID      EQUATE(INTERNET_ERROR_BASE + 38)
ERROR_INTERNET_HTTP_TO_HTTPS_ON_REDIR   EQUATE(INTERNET_ERROR_BASE + 39)
ERROR_INTERNET_HTTPS_TO_HTTP_ON_REDIR   EQUATE(INTERNET_ERROR_BASE + 40)
ERROR_INTERNET_MIXED_SECURITY           EQUATE(INTERNET_ERROR_BASE + 41)
ERROR_INTERNET_CHG_POST_IS_NON_SECURE   EQUATE(INTERNET_ERROR_BASE + 42)
ERROR_INTERNET_POST_IS_NON_SECURE       EQUATE(INTERNET_ERROR_BASE + 43)
ERROR_INTERNET_CLIENT_AUTH_CERT_NEEDED  EQUATE(INTERNET_ERROR_BASE + 44)
ERROR_INTERNET_INVALID_CA               EQUATE(INTERNET_ERROR_BASE + 45)
ERROR_INTERNET_CLIENT_AUTH_NOT_SETUP    EQUATE(INTERNET_ERROR_BASE + 46)
ERROR_INTERNET_ASYNC_THREAD_FAILED      EQUATE(INTERNET_ERROR_BASE + 47)
ERROR_INTERNET_REDIRECT_SCHEME_CHANGE   EQUATE(INTERNET_ERROR_BASE + 48)
ERROR_INTERNET_DIALOG_PENDING           EQUATE(INTERNET_ERROR_BASE + 49)
ERROR_INTERNET_RETRY_DIALOG             EQUATE(INTERNET_ERROR_BASE + 50)
ERROR_INTERNET_HTTPS_HTTP_SUBMIT_REDIR  EQUATE(INTERNET_ERROR_BASE + 52)
ERROR_INTERNET_INSERT_CDROM             EQUATE(INTERNET_ERROR_BASE + 53)
!
! FTP API errors
!
ERROR_FTP_TRANSFER_IN_PROGRESS          EQUATE(INTERNET_ERROR_BASE + 110)
ERROR_FTP_DROPPED                       EQUATE(INTERNET_ERROR_BASE + 111)
ERROR_FTP_NO_PASSIVE_MODE               EQUATE(INTERNET_ERROR_BASE + 112)
!
! gopher API errors
!
ERROR_GOPHER_PROTOCOL_ERROR             EQUATE(INTERNET_ERROR_BASE + 130)
ERROR_GOPHER_NOT_FILE                   EQUATE(INTERNET_ERROR_BASE + 131)
ERROR_GOPHER_DATA_ERROR                 EQUATE(INTERNET_ERROR_BASE + 132)
ERROR_GOPHER_END_OF_DATA                EQUATE(INTERNET_ERROR_BASE + 133)
ERROR_GOPHER_INVALID_LOCATOR            EQUATE(INTERNET_ERROR_BASE + 134)
ERROR_GOPHER_INCORRECT_LOCATOR_TYPE     EQUATE(INTERNET_ERROR_BASE + 135)
ERROR_GOPHER_NOT_GOPHER_PLUS            EQUATE(INTERNET_ERROR_BASE + 136)
ERROR_GOPHER_ATTRIBUTE_NOT_FOUND        EQUATE(INTERNET_ERROR_BASE + 137)
ERROR_GOPHER_UNKNOWN_LOCATOR            EQUATE(INTERNET_ERROR_BASE + 138)
!
! HTTP API errors
!
ERROR_HTTP_HEADER_NOT_FOUND             EQUATE(INTERNET_ERROR_BASE + 150)
ERROR_HTTP_DOWNLEVEL_SERVER             EQUATE(INTERNET_ERROR_BASE + 151)
ERROR_HTTP_INVALID_SERVER_RESPONSE      EQUATE(INTERNET_ERROR_BASE + 152)
ERROR_HTTP_INVALID_HEADER               EQUATE(INTERNET_ERROR_BASE + 153)
ERROR_HTTP_INVALID_QUERY_REQUEST        EQUATE(INTERNET_ERROR_BASE + 154)
ERROR_HTTP_HEADER_ALREADY_EXISTS        EQUATE(INTERNET_ERROR_BASE + 155)
ERROR_HTTP_REDIRECT_FAILED              EQUATE(INTERNET_ERROR_BASE + 156)
ERROR_HTTP_NOT_REDIRECTED               EQUATE(INTERNET_ERROR_BASE + 160)
ERROR_HTTP_COOKIE_NEEDS_CONFIRMATION    EQUATE(INTERNET_ERROR_BASE + 161)
ERROR_HTTP_COOKIE_DECLINED              EQUATE(INTERNET_ERROR_BASE + 162)
ERROR_HTTP_REDIRECT_NEEDS_CONFIRMATION  EQUATE(INTERNET_ERROR_BASE + 168)
!
! additional Internet API error codes
!
ERROR_INTERNET_SECURITY_CHANNEL_ERROR   EQUATE(INTERNET_ERROR_BASE + 157)
ERROR_INTERNET_UNABLE_TO_CACHE_FILE     EQUATE(INTERNET_ERROR_BASE + 158)
ERROR_INTERNET_TCPIP_NOT_INSTALLED      EQUATE(INTERNET_ERROR_BASE + 159)
ERROR_INTERNET_DISCONNECTED             EQUATE(INTERNET_ERROR_BASE + 163)
ERROR_INTERNET_SERVER_UNREACHABLE       EQUATE(INTERNET_ERROR_BASE + 164)
ERROR_INTERNET_PROXY_SERVER_UNREACHABLE EQUATE(INTERNET_ERROR_BASE + 165)
!
ERROR_INTERNET_BAD_AUTO_PROXY_SCRIPT     EQUATE(INTERNET_ERROR_BASE + 166)
ERROR_INTERNET_UNABLE_TO_DOWNLOAD_SCRIPT EQUATE(INTERNET_ERROR_BASE + 167)
ERROR_INTERNET_SEC_INVALID_CERT          EQUATE(INTERNET_ERROR_BASE + 169)
ERROR_INTERNET_SEC_CERT_REVOKED          EQUATE(INTERNET_ERROR_BASE + 170)
! InternetAutodial specific errors
ERROR_INTERNET_FAILED_DUETOSECURITYCHECK EQUATE(INTERNET_ERROR_BASE + 171)
!
INTERNET_ERROR_LAST                      EQUATE(ERROR_INTERNET_FAILED_DUETOSECURITYCHECK)
!
!=========================================================================
!
INTERNET_OPTION_CALLBACK                EQUATE(1)
INTERNET_OPTION_CONNECT_TIMEOUT         EQUATE(2)
INTERNET_OPTION_CONNECT_RETRIES         EQUATE(3)
INTERNET_OPTION_CONNECT_BACKOFF         EQUATE(4)
INTERNET_OPTION_SEND_TIMEOUT            EQUATE(5)
INTERNET_OPTION_CONTROL_SEND_TIMEOUT    EQUATE(INTERNET_OPTION_SEND_TIMEOUT)
INTERNET_OPTION_RECEIVE_TIMEOUT         EQUATE(6)
INTERNET_OPTION_CONTROL_RECEIVE_TIMEOUT EQUATE(INTERNET_OPTION_RECEIVE_TIMEOUT)
INTERNET_OPTION_DATA_SEND_TIMEOUT       EQUATE(7)
INTERNET_OPTION_DATA_RECEIVE_TIMEOUT    EQUATE(8)
INTERNET_OPTION_HANDLE_TYPE             EQUATE(9)
INTERNET_OPTION_LISTEN_TIMEOUT          EQUATE(11)
INTERNET_OPTION_READ_BUFFER_SIZE        EQUATE(12)
INTERNET_OPTION_WRITE_BUFFER_SIZE       EQUATE(13)
!
INTERNET_OPTION_ASYNC_ID                EQUATE(15)
INTERNET_OPTION_ASYNC_PRIORITY          EQUATE(16)
!
INTERNET_OPTION_PARENT_HANDLE           EQUATE(21)
INTERNET_OPTION_KEEP_CONNECTION         EQUATE(22)
INTERNET_OPTION_REQUEST_FLAGS           EQUATE(23)
INTERNET_OPTION_EXTENDED_ERROR          EQUATE(24)
!
INTERNET_OPTION_OFFLINE_MODE            EQUATE(26)
INTERNET_OPTION_CACHE_STREAM_HANDLE     EQUATE(27)
INTERNET_OPTION_USERNAME                EQUATE(28)
INTERNET_OPTION_PASSWORD                EQUATE(29)
INTERNET_OPTION_ASYNC                   EQUATE(30)
INTERNET_OPTION_SECURITY_FLAGS          EQUATE(31)
INTERNET_OPTION_SECURITY_CERTIFICATE_STRUCT EQUATE(32)
INTERNET_OPTION_DATAFILE_NAME           EQUATE(33)
INTERNET_OPTION_URL                     EQUATE(34)
INTERNET_OPTION_SECURITY_CERTIFICATE    EQUATE(35)
INTERNET_OPTION_SECURITY_KEY_BITNESS    EQUATE(36)
INTERNET_OPTION_REFRESH                 EQUATE(37)
INTERNET_OPTION_PROXY                   EQUATE(38)
INTERNET_OPTION_SETTINGS_CHANGED        EQUATE(39)
INTERNET_OPTION_VERSION                 EQUATE(40)
INTERNET_OPTION_USER_AGENT              EQUATE(41)
INTERNET_OPTION_END_BROWSER_SESSION     EQUATE(42)
INTERNET_OPTION_PROXY_USERNAME          EQUATE(43)
INTERNET_OPTION_PROXY_PASSWORD          EQUATE(44)
INTERNET_OPTION_CONTEXT_VALUE           EQUATE(45)
INTERNET_OPTION_CONNECT_LIMIT           EQUATE(46)
INTERNET_OPTION_SECURITY_SELECT_CLIENT_CERT EQUATE(47)
INTERNET_OPTION_POLICY                  EQUATE(48)
INTERNET_OPTION_DISCONNECTED_TIMEOUT    EQUATE(49)
INTERNET_OPTION_CONNECTED_STATE         EQUATE(50)
INTERNET_OPTION_IDLE_STATE              EQUATE(51)
INTERNET_OPTION_OFFLINE_SEMANTICS       EQUATE(52)
INTERNET_OPTION_SECONDARY_CACHE_KEY     EQUATE(53)
INTERNET_OPTION_CALLBACK_FILTER         EQUATE(54)
INTERNET_OPTION_CONNECT_TIME            EQUATE(55)
INTERNET_OPTION_SEND_THROUGHPUT         EQUATE(56)
INTERNET_OPTION_RECEIVE_THROUGHPUT      EQUATE(57)
INTERNET_OPTION_REQUEST_PRIORITY        EQUATE(58)
INTERNET_OPTION_HTTP_VERSION            EQUATE(59)
INTERNET_OPTION_RESET_URLCACHE_SESSION  EQUATE(60)
INTERNET_OPTION_ERROR_MASK              EQUATE(62)
!
INTERNET_FIRST_OPTION                   EQUATE(INTERNET_OPTION_CALLBACK)
INTERNET_LAST_OPTION                    EQUATE(INTERNET_OPTION_ERROR_MASK)
!
! access types for InternetOpen()
!
INTERNET_OPEN_TYPE_PRECONFIG                    EQUATE(0)   ! use registry configuration
INTERNET_OPEN_TYPE_DIRECT                       EQUATE(1)   ! direct to net
INTERNET_OPEN_TYPE_PROXY                        EQUATE(3)   ! via named proxy
INTERNET_OPEN_TYPE_PRECONFIG_WITH_NO_AUTOPROXY  EQUATE(4)   ! prevent using java/script/INS
!
! manifests
!
INTERNET_INVALID_PORT_NUMBER    EQUATE(0)           ! use the protocol-specific default
INTERNET_DEFAULT_FTP_PORT       EQUATE(21)          ! default for FTP servers
INTERNET_DEFAULT_GOPHER_PORT    EQUATE(70)          !    "     "  gopher "
INTERNET_DEFAULT_HTTP_PORT      EQUATE(80)          !    "     "  HTTP   "
INTERNET_DEFAULT_HTTPS_PORT     EQUATE(443)         !    "     "  HTTPS  "
INTERNET_DEFAULT_SOCKS_PORT     EQUATE(1080)        ! default for SOCKS firewall servers.
!
! flags common to open functions (not InternetOpen()):
!
INTERNET_FLAG_RELOAD            EQUATE(80000000h)  ! retrieve the original item
!
! flags for InternetOpenUrl():
!
INTERNET_FLAG_RAW_DATA          EQUATE(40000000h)  ! FTP/gopher find: receive the item as raw (structured) data
INTERNET_FLAG_EXISTING_CONNECT  EQUATE(20000000h)  ! FTP: use existing InternetConnect handle for server if possible
!
! flags for InternetOpen():
!
INTERNET_FLAG_ASYNC             EQUATE(10000000h)  ! this request is asynchronous (where supported)
!
! protocol-specific flags:
!
INTERNET_FLAG_PASSIVE           EQUATE(08000000h)  ! used for FTP connections
!
! additional cache flags
!
INTERNET_FLAG_NO_CACHE_WRITE    EQUATE(04000000)  ! don't write this item to the cache
INTERNET_FLAG_DONT_CACHE        EQUATE(INTERNET_FLAG_NO_CACHE_WRITE)
INTERNET_FLAG_MAKE_PERSISTENT   EQUATE(02000000)  ! make this item persistent in cache
INTERNET_FLAG_FROM_CACHE        EQUATE(01000000)  ! use offline semantics
INTERNET_FLAG_OFFLINE           EQUATE(INTERNET_FLAG_FROM_CACHE)
!
! additional flags
!
INTERNET_FLAG_SECURE            EQUATE(00800000h)  ! use PCT/SSL if applicable (HTTP)
INTERNET_FLAG_KEEP_CONNECTION   EQUATE(00400000h)  ! use keep-alive semantics
INTERNET_FLAG_NO_AUTO_REDIRECT  EQUATE(00200000h)  ! don't handle redirections automatically
INTERNET_FLAG_READ_PREFETCH     EQUATE(00100000h)  ! do background read prefetch
INTERNET_FLAG_NO_COOKIES        EQUATE(00080000h)  ! no automatic cookie handling
INTERNET_FLAG_NO_AUTH           EQUATE(00040000h)  ! no automatic authentication handling
INTERNET_FLAG_CACHE_IF_NET_FAIL EQUATE(00010000h)  ! return cache file if net request fails
!
! Security Ignore Flags, Allow HttpOpenRequest to overide
! Secure Channel (SSL/PCT) failures of the following types.
!
INTERNET_FLAG_IGNORE_REDIRECT_TO_HTTP   EQUATE(00008000h) ! ex: https:// to http://
INTERNET_FLAG_IGNORE_REDIRECT_TO_HTTPS  EQUATE(00004000h) ! ex: http:// to https://
INTERNET_FLAG_IGNORE_CERT_DATE_INVALID  EQUATE(00002000h) ! expired X509 Cert.
INTERNET_FLAG_IGNORE_CERT_CN_INVALID    EQUATE(00001000h) ! bad common name in X509 Cert.
!
! more caching flags
!
INTERNET_FLAG_RESYNCHRONIZE     EQUATE(00000800h)  ! asking wininet to update an item if it is newer
INTERNET_FLAG_HYPERLINK         EQUATE(00000400h)  ! asking wininet to do hyperlinking semantic which works right for scripts
INTERNET_FLAG_NO_UI             EQUATE(00000200h)  ! no cookie popup
INTERNET_FLAG_PRAGMA_NOCACHE    EQUATE(00000100h)  ! asking wininet to add "pragma: no-cache"
INTERNET_FLAG_CACHE_ASYNC       EQUATE(00000080h)  ! ok to perform lazy cache-write
INTERNET_FLAG_FORMS_SUBMIT      EQUATE(00000040h)  ! this is a forms submit
INTERNET_FLAG_NEED_FILE         EQUATE(00000010h)  ! need a file for this request
INTERNET_FLAG_MUST_CACHE_REQUEST EQUATE(INTERNET_FLAG_NEED_FILE)
!
! flags for FTP
!
INTERNET_SERVICE_URL    EQUATE(0)
INTERNET_SERVICE_FTP    EQUATE(1)
INTERNET_SERVICE_GOPHER EQUATE(2)
INTERNET_SERVICE_HTTP   EQUATE(3)
!
! InternetErrorDlg - Provides UI for certain Errors.
!
FLAGS_ERROR_UI_FILTER_FOR_ERRORS        EQUATE(01h)
FLAGS_ERROR_UI_FLAGS_CHANGE_OPTIONS     EQUATE(02h)
FLAGS_ERROR_UI_FLAGS_GENERATE_DATA      EQUATE(04h)
FLAGS_ERROR_UI_FLAGS_NO_UI              EQUATE(08h)
FLAGS_ERROR_UI_SERIALIZE_DIALOGS        EQUATE(10h)
!
!==========================================================================
!
! the default major/minor HTTP version numbers
!
!
HTTP_MAJOR_VERSION      EQUATE(1)
HTTP_MINOR_VERSION      EQUATE(0)

HTTP_VERSION            EQUATE('HTTP/1.0')

!
! HttpQueryInfo info levels. Generally, there is one info level
! for each potential RFC822/HTTP/MIME header that an HTTP server
! may send as part of a request response.
!
! The HTTP_QUERY_RAW_HEADERS info level is provided for clients
! that choose to perform their own header parsing.
!

HTTP_QUERY_MIME_VERSION                 EQUATE(0)
HTTP_QUERY_CONTENT_TYPE                 EQUATE(1)
HTTP_QUERY_CONTENT_TRANSFER_ENCODING    EQUATE(2)
HTTP_QUERY_CONTENT_ID                   EQUATE(3)
HTTP_QUERY_CONTENT_DESCRIPTION          EQUATE(4)
HTTP_QUERY_CONTENT_LENGTH               EQUATE(5)
HTTP_QUERY_CONTENT_LANGUAGE             EQUATE(6)
HTTP_QUERY_ALLOW                        EQUATE(7)
HTTP_QUERY_PUBLIC                       EQUATE(8)
HTTP_QUERY_DATE                         EQUATE(9)
HTTP_QUERY_EXPIRES                      EQUATE(10)
HTTP_QUERY_LAST_MODIFIED                EQUATE(11) 
HTTP_QUERY_MESSAGE_ID                   EQUATE(12)
HTTP_QUERY_URI                          EQUATE(13)
HTTP_QUERY_DERIVED_FROM                 EQUATE(14)
HTTP_QUERY_COST                         EQUATE(15)
HTTP_QUERY_LINK                         EQUATE(16)
HTTP_QUERY_PRAGMA                       EQUATE(17)
HTTP_QUERY_VERSION                      EQUATE(18)  ! special: part of status line
HTTP_QUERY_STATUS_CODE                  EQUATE(19)  ! special: part of status line
HTTP_QUERY_STATUS_TEXT                  EQUATE(20)  ! special: part of status line
HTTP_QUERY_RAW_HEADERS                  EQUATE(21)  ! special: all headers as ASCIIZ
HTTP_QUERY_RAW_HEADERS_CRLF             EQUATE(22)  ! special: all headers
HTTP_QUERY_CONNECTION                   EQUATE(23)
HTTP_QUERY_ACCEPT                       EQUATE(24)
HTTP_QUERY_ACCEPT_CHARSET               EQUATE(25)
HTTP_QUERY_ACCEPT_ENCODING              EQUATE(26)
HTTP_QUERY_ACCEPT_LANGUAGE              EQUATE(27)
HTTP_QUERY_AUTHORIZATION                EQUATE(28)
HTTP_QUERY_CONTENT_ENCODING             EQUATE(29)
HTTP_QUERY_FORWARDED                    EQUATE(30)
HTTP_QUERY_FROM                         EQUATE(31)
HTTP_QUERY_IF_MODIFIED_SINCE            EQUATE(32)
HTTP_QUERY_LOCATION                     EQUATE(33)
HTTP_QUERY_ORIG_URI                     EQUATE(34)
HTTP_QUERY_REFERER                      EQUATE(35)
HTTP_QUERY_RETRY_AFTER                  EQUATE(36)
HTTP_QUERY_SERVER                       EQUATE(37)
HTTP_QUERY_TITLE                        EQUATE(38)
HTTP_QUERY_USER_AGENT                   EQUATE(39)
HTTP_QUERY_WWW_AUTHENTICATE             EQUATE(40)
HTTP_QUERY_PROXY_AUTHENTICATE           EQUATE(41)
HTTP_QUERY_ACCEPT_RANGES                EQUATE(42)
HTTP_QUERY_SET_COOKIE                   EQUATE(43)
HTTP_QUERY_COOKIE                       EQUATE(44)
HTTP_QUERY_REQUEST_METHOD               EQUATE(45)  ! special: GET/POST etc.
HTTP_QUERY_REFRESH                      EQUATE(46)
HTTP_QUERY_CONTENT_DISPOSITION          EQUATE(47)

!
! HTTP 1.1 defined headers
!

HTTP_QUERY_AGE                          EQUATE(48)
HTTP_QUERY_CACHE_CONTROL                EQUATE(49)
HTTP_QUERY_CONTENT_BASE                 EQUATE(50)
HTTP_QUERY_CONTENT_LOCATION             EQUATE(51)
HTTP_QUERY_CONTENT_MD5                  EQUATE(52)
HTTP_QUERY_CONTENT_RANGE                EQUATE(53)
HTTP_QUERY_ETAG                         EQUATE(54)
HTTP_QUERY_HOST                         EQUATE(55)
HTTP_QUERY_IF_MATCH                     EQUATE(56)
HTTP_QUERY_IF_NONE_MATCH                EQUATE(57)
HTTP_QUERY_IF_RANGE                     EQUATE(58)
HTTP_QUERY_IF_UNMODIFIED_SINCE          EQUATE(59)
HTTP_QUERY_MAX_FORWARDS                 EQUATE(60)
HTTP_QUERY_PROXY_AUTHORIZATION          EQUATE(61)
HTTP_QUERY_RANGE                        EQUATE(62)
HTTP_QUERY_TRANSFER_ENCODING            EQUATE(63)
HTTP_QUERY_UPGRADE                      EQUATE(64)
HTTP_QUERY_VARY                         EQUATE(65)
HTTP_QUERY_VIA                          EQUATE(66)
HTTP_QUERY_WARNING                      EQUATE(67)

HTTP_QUERY_MAX                          EQUATE(67)

!
! HTTP_QUERY_CUSTOM - if this special value is supplied as the dwInfoLevel
! parameter of HttpQueryInfo() then the lpBuffer parameter contains the name
! of the header we are to query
!

HTTP_QUERY_CUSTOM                       EQUATE(65535)

!
! HTTP_QUERY_FLAG_REQUEST_HEADERS - if this bit is set in the dwInfoLevel
! parameter of HttpQueryInfo() then the request headers will be queried for the
! request information
!

HTTP_QUERY_FLAG_REQUEST_HEADERS         EQUATE(80000000h)

!
! HTTP_QUERY_FLAG_SYSTEMTIME - if this bit is set in the dwInfoLevel parameter
! of HttpQueryInfo() AND the header being queried contains date information,
! e.g. the "Expires:" header then lpBuffer will contain a SYSTEMTIME structure
! containing the date and time information converted from the header string
!

HTTP_QUERY_FLAG_SYSTEMTIME              EQUATE(40000000h)

!
! HTTP_QUERY_FLAG_NUMBER - if this bit is set in the dwInfoLevel parameter of
! HttpQueryInfo(), then the value of the header will be converted to a number
! before being returned to the caller, if applicable
!

HTTP_QUERY_FLAG_NUMBER                  EQUATE(20000000h)

!
! HTTP_QUERY_FLAG_COALESCE - combine the values from several headers of the
! same name into the output buffer
!

HTTP_QUERY_FLAG_COALESCE                EQUATE(10000000h)


HTTP_QUERY_MODIFIER_FLAGS_MASK          EQUATE(HTTP_QUERY_FLAG_REQUEST_HEADERS + |
                                               HTTP_QUERY_FLAG_SYSTEMTIME      + |
                                               HTTP_QUERY_FLAG_NUMBER          + |
                                               HTTP_QUERY_FLAG_COALESCE          )

HTTP_QUERY_HEADER_MASK                  EQUATE(-HTTP_QUERY_MODIFIER_FLAGS_MASK)

!
! HTTP Response Status Codes:
!

HTTP_STATUS_CONTINUE            EQUATE(100) ! OK to continue with request
HTTP_STATUS_SWITCH_PROTOCOLS    EQUATE(101) ! server has switched protocols in upgrade header

HTTP_STATUS_OK                  EQUATE(200) ! request completed
HTTP_STATUS_CREATED             EQUATE(201) ! object created, reason = new URI
HTTP_STATUS_ACCEPTED            EQUATE(202) ! async completion (TBS)
HTTP_STATUS_PARTIAL             EQUATE(203) ! partial completion
HTTP_STATUS_NO_CONTENT          EQUATE(204) ! no info to return
HTTP_STATUS_RESET_CONTENT       EQUATE(205) ! request completed, but clear form
HTTP_STATUS_PARTIAL_CONTENT     EQUATE(206) ! partial GET furfilled

HTTP_STATUS_AMBIGUOUS           EQUATE(300) ! server couldn't decide what to return
HTTP_STATUS_MOVED               EQUATE(301) ! object permanently moved
HTTP_STATUS_REDIRECT            EQUATE(302) ! object temporarily moved
HTTP_STATUS_REDIRECT_METHOD     EQUATE(303) ! redirection w/ new access method
HTTP_STATUS_NOT_MODIFIED        EQUATE(304) ! if-modified-since was not modified
HTTP_STATUS_USE_PROXY           EQUATE(305) ! redirection to proxy, location header specifies proxy to use
HTTP_STATUS_REDIRECT_KEEP_VERB  EQUATE(307) ! HTTP/1.1: keep same verb

HTTP_STATUS_BAD_REQUEST         EQUATE(400) ! invalid syntax
HTTP_STATUS_DENIED              EQUATE(401) ! access denied
HTTP_STATUS_PAYMENT_REQ         EQUATE(402) ! payment required
HTTP_STATUS_FORBIDDEN           EQUATE(403) ! request forbidden
HTTP_STATUS_NOT_FOUND           EQUATE(404) ! object not found
HTTP_STATUS_BAD_METHOD          EQUATE(405) ! method is not allowed
HTTP_STATUS_NONE_ACCEPTABLE     EQUATE(406) ! no response acceptable to client found
HTTP_STATUS_PROXY_AUTH_REQ      EQUATE(407) ! proxy authentication required
HTTP_STATUS_REQUEST_TIMEOUT     EQUATE(408) ! server timed out waiting for request
HTTP_STATUS_CONFLICT            EQUATE(409) ! user should resubmit with more info
HTTP_STATUS_GONE                EQUATE(410) ! the resource is no longer available
HTTP_STATUS_LENGTH_REQUIRED     EQUATE(411) ! the server refused to accept request w/o a length
HTTP_STATUS_PRECOND_FAILED      EQUATE(412) ! precondition given in request failed
HTTP_STATUS_REQUEST_TOO_LARGE   EQUATE(413) ! request entity was too large
HTTP_STATUS_URI_TOO_LONG        EQUATE(414) ! request URI too long
HTTP_STATUS_UNSUPPORTED_MEDIA   EQUATE(415) ! unsupported media type

HTTP_STATUS_SERVER_ERROR        EQUATE(500) ! internal server error
HTTP_STATUS_NOT_SUPPORTED       EQUATE(501) ! required not supported
HTTP_STATUS_BAD_GATEWAY         EQUATE(502) ! error response received from gateway
HTTP_STATUS_SERVICE_UNAVAIL     EQUATE(503) ! temporarily overloaded
HTTP_STATUS_GATEWAY_TIMEOUT     EQUATE(504) ! timed out waiting for gateway
HTTP_STATUS_VERSION_NOT_SUP     EQUATE(505) ! HTTP version not supported

HTTP_STATUS_FIRST               EQUATE(HTTP_STATUS_CONTINUE)
HTTP_STATUS_LAST                EQUATE(HTTP_STATUS_VERSION_NOT_SUP)
!
! flags for HttpSendRequestEx(), HttpEndRequest()
!
HSR_ASYNC       EQUATE(WININET_API_FLAG_ASYNC)         ! force async
HSR_SYNC        EQUATE(WININET_API_FLAG_SYNC)          ! force sync
HSR_USE_CONTEXT EQUATE(WININET_API_FLAG_USE_CONTEXT)   ! use dwContext value
HSR_INITIATE    EQUATE(00000008h)                      ! iterative operation (completed by HttpEndRequest)
HSR_DOWNLOAD    EQUATE(00000010h)                      ! download to file
HSR_CHUNKED     EQUATE(00000020h)                      ! operation is send of chunked data

!
   SECTION('Types')
INTERNET_BUFFERS  GROUP,TYPE,PRE()
StructSize           DWORD      ! Double-word value used for API versioning. Set to the size of the INTERNET_BUFFERS structure.
Next                 LONG       ! Address of the next INTERNET_BUFFERS structure.
Header               LONG       ! Pointer string value containing the headers. This value can be NULL.
HeadersLength        DWORD      ! Double-word value containing the length of the headers if Header is not NULL.
HeadersTotal         DWORD      ! Double-word value that contains the size of the headers if there is not enough memory in the buffer. 
Buffer               LONG       ! Address of the data buffer.
BufferLength         DWORD      ! Double-word value that contains the length of the buffer if Buffer is not NULL.
BufferTotal          DWORD      ! Double-word value that contains the total size of the chunk or the content length if it is not chunked. 
OffsetLow            DWORD      ! Double-word value that is used for read ranges. 
OffsetHigh           DWORD      ! Double-word value that is used for read ranges.
                  END

   SECTION('Prototypes')
   MODULE('WiniNet')
      InternetCloseHandle(HINTERNET ConnectSession),BOOL,PASCAL,NAME('InternetCloseHandle'),PROC
      InternetErrorDlg(HWND hWnd,               |
                LONG  Internet,                 |
                DWORD Err,                      |
                DWORD Flags,                    |
                LONG  DataAdr),DWORD,RAW,PASCAL,NAME('InternetErrorDlg')
      InternetOpen(LONG Agent,                  |
                DWORD   AccessType,             |
                LONG    ProxyName,              |
                LONG    ProxyBypass,            |
                DWORD   Flags),HINTERNET,RAW,PASCAL,NAME('InternetOpenA')
      InternetOpenUrl(HINTERNET InternetSession,|
                LONG    Url,                    |
                LONG    Headers,                |
                DWORD   HeadersLength,          |
                DWORD   Flags,                  |
                DWORD   Context),HINTERNET,RAW,PASCAL,NAME('InternetOpenUrlA')
      InternetConnect(HINTERNET ConnectSession, |
                LONG    ServerName,             |
                INTERNET_PORT ServerPort,       |
                LONG    Username,               |
                LONG    Password,               |
                DWORD   Service,                |
                DWORD   Flags,                  |
                DWORD   Context),HINTERNET,RAW,PASCAL,NAME('InternetConnectA')
		InternetGetLastResponseInfo(LONG aError,  |
										    LONG Buffer,  |
										    LONG BufferLength),BOOL,PASCAL,NAME('InternetGetLastResponseInfoA')
      InternetReadFile(HINTERNET File,          |
                LONG  Buffer,                   |
                DWORD NumberOfBytesToRead,      |
                LONG  NumberOfBytesRead),BOOL,RAW,PASCAL,NAME('InternetReadFile')
      InternetSetOption(HINTERNET Connect,      |
                DWORD Option,                   |
                LONG  Buffer,                   |
                DWORD BufferLength),BOOL,RAW,PASCAL,NAME('InternetSetOptionA')
      InternetQueryDataAvailable(HINTERNET File,|
                LONG  NumberOfBytesAvailable,   |
                DWORD Flags,                    |
                DWORD Context),BOOL,RAW,PASCAL,NAME('InternetQueryDataAvailable')
      InternetQueryOption(HINTERNET Internet,   |
                DWORD Option,                   |
                LONG  pBuffer,                  |
                LONG  BufferLength),BOOL,RAW,PASCAL,NAME('InternetQueryOptionA')
      InternetWriteFile(HINTERNET File,         |
                LONG  pBuffer,                  |
                DWORD NumberOfBytesToWrite,     |
                LONG  NumberOfBytesWritten),BOOL,PASCAL,RAW,NAME('InternetWriteFile')
      FtpCreateDirectory(HINTERNET FtpSession,  |
                LONG  DirectoryName),BOOL,PASCAL,NAME('FtpCreateDirectoryA')
      FtpGetCurrentDirectory(HINTERNET FtpSession,|
                LONG  CurrentDirectory,         |
                LONG  CurrentDirectorySize),BOOL,PASCAL,NAME('FtpGetCurrentDirectoryA')
      FtpDeleteFile(HINTERNET FtpSession,       |
                LONG FileName),BOOL,PASCAL,NAME('FtpDeleteFileA')
      FtpFindFirstFile(HINTERNET FtpSession,    |
                LONG  SearchFile,               |
                LONG  FindFileData,             |
                DWORD Flags,                    |
                DWORD Context),HINTERNET,PASCAL,NAME('FtpFindFirstFileA')
      FtpGetFile(HINTERNET FtpSession,          |
                LONG  RemoteFile,               |  
                LONG  NewFile,                  |
                BOOL  FailIfExists,             |
                DWORD LocalFlagsAndAttributes,  |
                DWORD InternetFlags,            |
                DWORD Context),BOOL,PASCAL,NAME('FtpGetFileA')
      FtpGetFileSize(HANDLE hFile,              |
                LONG FileSizeHigh),LONG,PASCAL,NAME('FtpGetFileSize')
      FtpOpenFile(HINTERNET FtpSession,         |
                LONG  FileName,                 |
                DWORD Access,                   |
                DWORD Flags,                    |
                DWORD Context),HINTERNET,PASCAL,NAME('FtpOpenFileA')
      FtpPutFile(HINTERNET FtpSession,          |
                LONG  LocalFile,                |
                LONG  NewRemoteFile,            |
                DWORD Flags,                    | 
                DWORD Context),BOOL,PASCAL,NAME('FtpPutFileA')
      FtpRemoveDirectory(HINTERNET FtpSession,  |
                LONG DirectoryName),BOOL,PASCAL,NAME('FtpRemoveDirectoryA')
      FtpRenameFile(HINTERNET FtpSession,       |
                LONG Existing,                  |
                LONG NewFileName),BOOL,PASCAL,NAME('FtpRenameFileA')
      FtpSetCurrentDirectory(HINTERNET FtpSession,|
                LONG DirectoryName),BOOL,PASCAL,NAME('FtpSetCurrentDirectoryA')
      InternetFindNextFile(HINTERNET Find,      |
                LONG FindData),BOOL,PASCAL,NAME('InternetFindNextFileA')
      HttpEndRequest(HINTERNET Request,         |
                LONG  BuffersOut,               |
                DWORD Flags,                    |
                DWORD Context),BOOL,PASCAL,RAW,NAME('HttpEndRequestA')
      HttpOpenRequest(HINTERNET HttpSession,    |
                LONG  Verb,                     |
                LONG  ObjectName,               |
                LONG  Version,                  |
                LONG  Referer,                  |
                LONG  AcceptTypes,              |
                DWORD Flags,                    |
                DWORD Context),HINTERNET,RAW,PASCAL,NAME('HttpOpenRequestA')
      HttpSendRequest(HINTERNET HttpRequest,    |
                LONG  Headers,                  |
                DWORD HeadersLength,            |
                LONG  Optional,                 |
                DWORD OptionalLength),BOOL,RAW,PASCAL,NAME('HttpSendRequestA')
      HttpSendRequestEx(HINTERNET Request,      |
                LONG  BuffersIn,                |
                LONG  BuffersOut,               |
                DWORD Flags,                    |
                DWORD Context),BOOL,RAW,PASCAL,NAME('HttpSendRequestExA')
      HttpQueryInfo(HINTERNET HttpRequest,      |
                DWORD   InfoLevel,              |
                LONG    Buffer,                 |
                LONG    BufferLength,           |
                LONG    Index),BOOL,RAW,PASCAL,NAME('HttpQueryInfoA')
   END
