   Section('Equates')

   include('svapi.inc')

!WM_CLOSE               EQUATE(0010h)
!WM_QUERYENDSESSION     EQUATE(00011H)
!WM_ENDSESSION          EQUATE(00016H)


MAXDWORD               EQUATE(0FFFFFFFFh)
!MAX_PATH               EQUATE(260)
ERROR_NO_MORE_FILES    EQUATE(18)

WORD           EQUATE(SIGNED)
UINT                EQUATE(UNSIGNED)
CHAR           EQUATE(BYTE)
LPVOID         EQUATE(ULONG)
HINTERNET      EQUATE(LPVOID)
INTERNET_PORT  EQUATE(WORD)
LPCSTR         EQUATE(CSTRING)
DWORD          EQUATE(ULONG)
LPDWORD        EQUATE(ULONG)
HANDLE         EQUATE(UNSIGNED)
HINSTANCE      EQUATE(HANDLE)
LPCTSTR        EQUATE(CSTRING)
HMODULE        EQUATE(HINSTANCE)
HWND           EQUATE(HANDLE)
HDC            EQUATE(HANDLE)
LPARAM         EQUATE(LONG)
WPARAM          EQUATE(UNSIGNED)
WNDPROC         EQUATE(LONG)

!GENERIC_READ                       EQUATE(80000000h)
!GENERIC_WRITE                      EQUATE(40000000h)
!GENERIC_EXECUTE                    EQUATE(20000000h)
!GENERIC_ALL                        EQUATE(10000000h)

!FILE_SHARE_READ                    EQUATE(00000001h)
!FILE_SHARE_WRITE                   EQUATE(00000002h)
!FILE_SHARE_DELETE                  EQUATE(00000004h)
!FILE_ATTRIBUTE_READONLY            EQUATE(00000001h)
!FILE_ATTRIBUTE_HIDDEN              EQUATE(00000002h)
!FILE_ATTRIBUTE_SYSTEM              EQUATE(00000004h)
!FILE_ATTRIBUTE_DIRECTORY           EQUATE(00000010h)
!FILE_ATTRIBUTE_ARCHIVE             EQUATE(00000020h)
!FILE_ATTRIBUTE_ENCRYPTED           EQUATE(00000040h)
!FILE_ATTRIBUTE_NORMAL              EQUATE(00000080h)
!FILE_ATTRIBUTE_TEMPORARY           EQUATE(00000100h)
!FILE_ATTRIBUTE_SPARSE_FILE         EQUATE(00000200h)
!FILE_ATTRIBUTE_REPARSE_POINT       EQUATE(00000400h)
!FILE_ATTRIBUTE_COMPRESSED          EQUATE(00000800h)
!FILE_ATTRIBUTE_OFFLINE             EQUATE(00001000h)
!FILE_ATTRIBUTE_NOT_CONTENT_INDEXED EQUATE(00002000h)
!
! File creation flags must start at the high end since they
! are combined with the attributes
!
!FILE_FLAG_WRITE_THROUGH          EQUATE(80000000h)
!FILE_FLAG_OVERLAPPED             EQUATE(40000000h)
!FILE_FLAG_NO_BUFFERING           EQUATE(20000000h)
!FILE_FLAG_RANDOM_ACCESS          EQUATE(10000000h)
!FILE_FLAG_SEQUENTIAL_SCAN        EQUATE(08000000h)
!FILE_FLAG_DELETE_ON_CLOSE        EQUATE(04000000h)
!FILE_FLAG_BACKUP_SEMANTICS       EQUATE(02000000h)
!FILE_FLAG_POSIX_SEMANTICS        EQUATE(01000000h)
!FILE_FLAG_OPEN_REPARSE_POINT     EQUATE(00200000h)
!FILE_FLAG_OPEN_NO_RECALL         EQUATE(00100000h)
!
!CREATE_NEW           EQUATE(1)
!CREATE_ALWAYS        EQUATE(2)
!OPEN_EXISTING        EQUATE(3)
!OPEN_ALWAYS          EQUATE(4)
!TRUNCATE_EXISTING    EQUATE(5)

INVALID_HANDLE_VALUE EQUATE(-1)


   SECTION('Types')

FILETIME            GROUP,TYPE
LowDateTime            DWORD
HighDateTime           DWORD
                    END

SYSTEMTIME          GROUP,TYPE
Year                   WORD
Month                  WORD
DayOfWeek              WORD
Day                    WORD
Hour                   WORD
Minute                 WORD
Second                 WORD
Milliseconds           WORD
                    END

WIN32_FIND_DATA     GROUP,TYPE
FileAttributes         DWORD
CreationTime           LIKE(FILETIME)
LastAccessTime         LIKE(FILETIME)
LastWriteTime          LIKE(FILETIME)
FileSizeHigh           DWORD
FileSizeLow            DWORD
Reserved0              DWORD
Reserved1              DWORD
FileName               CSTRING(MAX_PATH)
AlternateFileName      CSTRING(14)
                    END

!SECURITY_ATTRIBUTES  GROUP,TYPE
!Length                  DWORD
!SecurityDescriptor      LONG
!InheritHandle           BOOL
!                     END

OVERLAPPED           GROUP,TYPE
Internal                DWORD
InternalHigh            DWORD
Offset                  DWORD
OffsetHigh              DWORD
hEvent                  HANDLE
                     END

   SECTION('Prototypes')
   MODULE('Windows')
      GetDesktopWindow(),UNSIGNED,PASCAL
! pointer to UTC file time to convert
! pointer to converted file time
      FileTimeToLocalFileTime(LONG FileTime,LONG LocalFileTime),BOOL,PASCAL,PROC
! pointer to file time to convert
! pointer to structure to receive system time
      FileTimeToSystemTime(LONG FileTime,LONG SystemTime),BOOL,RAW,PASCAL,PROC
! pointer to name of the file
! access (read-write) mode
! share mode
! pointer to security attributes
! how to create
! file attributes
! handle to file with attributes to copy
      CreateFile(LONG FileName,             |
                 DWORD DesiredAccess,       |
                 DWORD ShareMode,           |
                 LONG  SecurityAttributes,  |
                 DWORD CreationDisposition, |
                 DWORD FlagsAndAttributes,  |
                 HANDLE TemplateFile),UNSIGNED,RAW,PASCAL,NAME('CreateFileA')
! handle to file to write to
! pointer to data to write to file
! number of bytes to write
! pointer to number of bytes written
! pointer to structure for overlapped I/O
      WriteFile(HANDLE File,                  |
                 LONG   Buffer,               |
                 DWORD  NumberOfBytesToWrite, |
                 LONG   NumberOfBytesWritten, |
                 LONG   Overlapped),BOOL,RAW,PASCAL,NAME('WriteFile')
! handle of file to read
! pointer to buffer that receives data
! number of bytes to read
! pointer to number of bytes read
! pointer to structure for data
      ReadFile(HANDLE FileHandle,             |
               LONG   Buffer,                 |
               DWORD  NumberOfBytesToRead,    |
               LONG   NumberOfBytesRead,      |
               LONG   Overlapped),BOOL,RAW,PASCAL,NAME('ReadFile')
! handle to object to close
      CloseHandle(HANDLE hObject),BOOL,PASCAL,PROC
! open handle to file whose buffers are to be flushed
      FlushFileBuffers(HANDLE hFile),BOOL,PASCAL,PROC
! handle of file to get size of, pointer to high-order word for file size
      GetFileSize(HANDLE hFile,LONG FileSizeHigh),ULONG,PASCAL,RAW
      SetWindowLong(HWND      WindowHandle, |
                    SIGNED    SetIndex,     |
                    LONG      NewLong),LONG,PASCAL,NAME('SetWindowLongA')
      CallWindowProc(WNDPROC  PrevWndFunc,  |
                     HWND     WindowHandle, |
                     UINT     WinMsg,       |
                     WPARAM   FirstParam,   |
                     LPARAM   SecondParam),LONG,PASCAL,NAME('CallWindowProcA')
   END
